<script>
import { GlButton, GlFormTextarea, GlCard } from '@gitlab/ui';
import PromptSelector from '@/components/PromptSelector.vue';
import { sendPrompt } from '../utils/commonUtils';

export default {
    name: 'PromptWindow',
    components: { PromptSelector, GlCard, GlButton, GlFormTextarea },
    props: ['infoObject', 'settings', 'extensionId'],
    data() {
        return {
            debugVal: '',
            promptText:
                '[[code]]\n"""\nHere is what the above code is doing, explained in a concise way maybe:\n1.',
            sendingPrompt: false,
            finalPrompt: '',
            resultText: '',
            resultObject: null,
        };
    },
    mounted() {
        console.log('PromptWindow: received settings:', this.settings);
        console.log('extension id', this.extensionId);
    },
    methods: {
        async sendToAPI() {
            this.debugVal = ''
            if (this.settings.key) {
                this.sendingPrompt = true;
                this.resultObject = null;
                this.resultText = '';
                this.finalPrompt = '';

                let parsedPrompt = this.promptText;

                const re = /\[\[(.+?)\]\]/g;
                let match;
                while ((match = re.exec(parsedPrompt))) {
                    if (this.infoObject[match[1]]) {
                        parsedPrompt = parsedPrompt.replace(match[0], this.infoObject[match[1]]);
                    }
                }

                this.finalPrompt = parsedPrompt;
                try {
                    const { response } = await sendPrompt(this.extensionId, this.finalPrompt);
                    if (response?.error) {
                         this.debugVal = response.error.message;
                    } else {
                        this.resultObject = response;
                        if (response?.choices?.length > 0) {
                        this.resultText = response.choices[0].text;
                    }
                    
                }
                } catch (e) {
                    console.error(e)
                    this.debugVal = e?.message;
                    // check for detailed error message
                    if (e?.response?.data?.error) {
                        this.debugVal += ' Details:' + e.response.data.error.message
                    }
                } finally {
                    this.sendingPrompt = false;
                }            
            } else {
                this.debugVal = 'No Open AI Key';
            }
        },
        updatePrompt(newPrompt) {
            this.promptText = newPrompt;
        },
        formatTextToHTML(text) {
            if (text && text.replaceAll) {
                text = text.replaceAll('<', '&lt;').replaceAll('>', '&gt;').replaceAll('\n', '<br/>');
                return text;
            }
        },
    },
};
</script>

<template>
    <div class="gl-px-4 gl-py-4">
        <!-- <link rel="stylesheet" media="all" href="css/utility_classes.css" />
        <link rel="stylesheet" media="all" href="css/index.css" /> -->
        <div class="gl-display-flex">
            <div class="gl-flex-grow-1">
                <h2>GitLab AI Testbed</h2>
            </div>
        </div>
        <div class="gl-display-flex">
            <div class="gl-w-half gl-flex-grow-1 gl-mr-2">
                <div class="gl-font-size-h4 gl-font-weight-bold gl-mb-5 gl-pt-2">
                    Page (Type {{ infoObject.pageId }})
                </div>
                <table class="gl-w-full">
                    <tr v-for="(value, key, ind) in infoObject" :key="ind" class="gl-font-sm gl-border-1 gl-border-t-solid">
                        <td style="vertical-align: top" class="gl-font-weight-bold">{{ key }}:</td>
                        <td class="gl-px-3">
                            <div style="
                        overflow: hidden;
                        display: -webkit-box;
                        -webkit-line-clamp: 10; /* number of lines to show */
                        line-clamp: 10;
                        -webkit-box-orient: vertical;
                      " v-html="formatTextToHTML(value)"></div>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="gl-w-half gl-flex-grow-1">
                <div class="gl-display-flex gl-mb-3">
                    <div class="gl-w-half gl-flex-grow-1 gl-font-size-4 gl-font-weight-bold gl-pt-2">
                        Prompt:
                    </div>
                    <div class="gl-w-half gl-flex-grow-1 gl-text-right">
                        <prompt-selector @promptLoaded="updatePrompt" />
                    </div>
                </div>
                <GlFormTextarea v-model="promptText" style="min-height: 300px" />
            </div>
        </div>
        <hr />
        <div class="gl-display-flex gl-mt-2">
            <div class="gl-w-half gl-flex-grow-1">
                <div class="gl-display-flex">
                    <div class="gl-mr-4">OpenAI API Key Configured:</div>
                    <div> {{ !!settings?.key }}</div>
                </div>
                <div class="gl-display-flex" v-if="settings?.extra_config">
                    <div class="gl-mr-4">Extra Config:</div>
                    <div> {{ settings?.extra_config}}</div>
                </div>
            </div>
            <div class="gl-w-half gl-flex-grow-1">
                <GlButton class="gl-align-right" :loading="sendingPrompt" :block="true" category="primary" variant="confirm"
                    @click="sendToAPI">Send to API</GlButton>
                <br/>
                <div v-if="debugVal" class="gl-font-sm">                
                    Debug: {{ debugVal }}
                </div>
            </div>
        </div>

        <div v-if="resultText">
            <gl-card class="gl-mt-3">
                <template #header>
                    <h3 class="gl-my-0 gl-font-weight-bold gl-font-lg">Result</h3>
                </template>
                <template #default>
                    <div v-html="formatTextToHTML(resultText)"></div>
                </template>
                <template #footer v-if="resultObject.usage">
                    <div class="gl-text-sm">
                        Prompt Tokens: {{ resultObject.usage.prompt_tokens }} / Completion Tokens:
                        {{ resultObject.usage.prompt_tokens }} / Total Tokens:
                        {{ resultObject.usage.prompt_tokens }}
                    </div>
                </template>
            </gl-card>
        </div>
        <div v-if="finalPrompt">
            <hr />
            <div class="gl-font-weight-bold">Final Prompt that was sent after parsing:</div>
            <div class="gl-panel">
                <div class="gl-font-sm" v-html="formatTextToHTML(finalPrompt)"></div>
            </div>
        </div>
        <div v-if="resultObject">
            <hr />
            <div class="gl-font-weight-bold">Result Object:</div>
            <div class="gl-font-sm">{{ resultObject }}</div>
        </div>
    </div>
</template>